/* UserUtils.c generated by valac 0.48.10, the Vala compiler
 * generated from UserUtils.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <rest/rest-proxy-call.h>
#include <rest/oauth-proxy.h>
#include "CbUserStream.h"
#include "CbUserCounter.h"
#include "CbFilter.h"
#include <rest/rest-proxy.h>
#include "CbUtils.h"

#define TYPE_CURSOR (cursor_get_type ())
typedef struct _Cursor Cursor;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ACCOUNT (account_get_type ())
#define ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT, Account))
#define ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT, AccountClass))
#define IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT))
#define IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT))
#define ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT, AccountClass))

typedef struct _Account Account;
typedef struct _AccountClass AccountClass;
typedef struct _AccountPrivate AccountPrivate;

#define SQL_TYPE_DATABASE (sql_database_get_type ())
#define SQL_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_DATABASE, SqlDatabase))
#define SQL_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_DATABASE, SqlDatabaseClass))
#define SQL_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_DATABASE))
#define SQL_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_DATABASE))
#define SQL_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_DATABASE, SqlDatabaseClass))

typedef struct _SqlDatabase SqlDatabase;
typedef struct _SqlDatabaseClass SqlDatabaseClass;

#define TYPE_NOTIFICATION_MANAGER (notification_manager_get_type ())
#define NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManager))
#define NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))
#define IS_NOTIFICATION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_MANAGER))
#define IS_NOTIFICATION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_MANAGER))
#define NOTIFICATION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_MANAGER, NotificationManagerClass))

typedef struct _NotificationManager NotificationManager;
typedef struct _NotificationManagerClass NotificationManagerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
typedef struct _UserUtilsLoadFriendshipData UserUtilsLoadFriendshipData;
#define _cursor_free0(var) ((var == NULL) ? NULL : (var = (cursor_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
typedef struct _UserUtilsLoadFollowersData UserUtilsLoadFollowersData;
typedef struct _UserUtilsLoadFollowingData UserUtilsLoadFollowingData;
typedef struct _Block55Data Block55Data;
typedef struct _UserUtilsMuteUserData UserUtilsMuteUserData;
typedef struct _Block56Data Block56Data;
typedef struct _UserUtilsBlockUserData UserUtilsBlockUserData;

struct _Cursor {
	gint64 next_cursor;
	gboolean full;
	JsonNode* json_object;
};

struct _Account {
	GObject parent_instance;
	AccountPrivate * priv;
	gint64 id;
	gint64 migration_date;
	gboolean suppress_dm_notifications;
	gboolean suppress_mention_notifications;
	SqlDatabase* db;
	gchar* screen_name;
	gchar* name;
	gchar* avatar_url;
	gchar* banner_url;
	gchar* website;
	gchar* description;
	OAuthProxy* proxy;
	CbUserStream* user_stream;
	CbUserCounter* user_counter;
	NotificationManager* notifications;
	gint64* friends;
	gint friends_length1;
	gint64* blocked;
	gint blocked_length1;
	gint64* muted;
	gint muted_length1;
	gint64* disabled_rts;
	gint disabled_rts_length1;
	GPtrArray* filters;
};

struct _AccountClass {
	GObjectClass parent_class;
};

struct _UserUtilsLoadFriendshipData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 user_id;
	gchar* screen_name;
	guint result;
	RestProxyCall* call;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	RestProxyCall* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	RestProxyCall* _tmp10_;
	JsonNode* root;
	JsonNode* _tmp11_;
	RestProxyCall* _tmp12_;
	JsonNode* _tmp13_;
	JsonNode* _tmp14_;
	GError* e;
	GError* _tmp15_;
	const gchar* _tmp16_;
	JsonObject* relationship;
	JsonNode* _tmp17_;
	JsonObject* _tmp18_;
	JsonObject* _tmp19_;
	JsonObject* _tmp20_;
	JsonObject* target;
	JsonObject* _tmp21_;
	JsonObject* _tmp22_;
	JsonObject* _tmp23_;
	JsonObject* source;
	JsonObject* _tmp24_;
	JsonObject* _tmp25_;
	JsonObject* _tmp26_;
	guint friendship;
	JsonObject* _tmp27_;
	JsonObject* _tmp28_;
	JsonObject* _tmp29_;
	JsonObject* _tmp30_;
	JsonObject* _tmp31_;
	GError* _inner_error0_;
};

struct _UserUtilsLoadFollowersData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 user_id;
	Cursor* old_cursor;
	Cursor* result;
	RestProxyCall* call;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	RestProxyCall* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	RestProxyCall* _tmp10_;
	RestProxyCall* _tmp11_;
	RestProxyCall* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	JsonNode* root;
	JsonNode* _tmp15_;
	RestProxyCall* _tmp16_;
	JsonNode* _tmp17_;
	JsonNode* _tmp18_;
	GError* e;
	GError* _tmp19_;
	const gchar* _tmp20_;
	JsonObject* root_obj;
	JsonNode* _tmp21_;
	JsonObject* _tmp22_;
	JsonObject* _tmp23_;
	JsonArray* user_array;
	JsonObject* _tmp24_;
	JsonArray* _tmp25_;
	JsonArray* _tmp26_;
	Cursor cursor;
	JsonObject* _tmp27_;
	JsonArray* _tmp28_;
	JsonObject* _tmp29_;
	JsonNode* _tmp30_;
	JsonNode* _tmp31_;
	Cursor _tmp32_;
	Cursor* _tmp33_;
	Cursor* _tmp34_;
	GError* _inner_error0_;
};

struct _UserUtilsLoadFollowingData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 user_id;
	Cursor* old_cursor;
	Cursor* result;
	RestProxyCall* call;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	RestProxyCall* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	RestProxyCall* _tmp10_;
	RestProxyCall* _tmp11_;
	RestProxyCall* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	JsonNode* root;
	JsonNode* _tmp15_;
	RestProxyCall* _tmp16_;
	JsonNode* _tmp17_;
	JsonNode* _tmp18_;
	GError* e;
	GError* _tmp19_;
	const gchar* _tmp20_;
	JsonObject* root_obj;
	JsonNode* _tmp21_;
	JsonObject* _tmp22_;
	JsonObject* _tmp23_;
	JsonArray* user_array;
	JsonObject* _tmp24_;
	JsonArray* _tmp25_;
	JsonArray* _tmp26_;
	Cursor cursor;
	JsonObject* _tmp27_;
	JsonArray* _tmp28_;
	JsonObject* _tmp29_;
	JsonNode* _tmp30_;
	JsonNode* _tmp31_;
	Cursor _tmp32_;
	Cursor* _tmp33_;
	Cursor* _tmp34_;
	GError* _inner_error0_;
};

struct _Block55Data {
	int _ref_count_;
	RestProxyCall* call;
	GError* err;
	gboolean setting;
	gpointer _async_data_;
};

struct _UserUtilsMuteUserData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 to_block;
	gboolean setting;
	Block55Data* _data55_;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	RestProxyCall* _tmp6_;
	RestProxyCall* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	RestProxyCall* _tmp10_;
	GError* _tmp11_;
	GError* _tmp12_;
	GError* _tmp13_;
	GError* _inner_error0_;
};

struct _Block56Data {
	int _ref_count_;
	RestProxyCall* call;
	GError* err;
	gboolean setting;
	gpointer _async_data_;
};

struct _UserUtilsBlockUserData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	Account* account;
	gint64 to_block;
	gboolean setting;
	Block56Data* _data56_;
	OAuthProxy* _tmp0_;
	RestProxyCall* _tmp1_;
	RestProxyCall* _tmp2_;
	RestProxyCall* _tmp3_;
	RestProxyCall* _tmp4_;
	RestProxyCall* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	RestProxyCall* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	GError* _inner_error0_;
};

#define FRIENDSHIP_FOLLOWED_BY ((guint) (1 << 0))
#define FRIENDSHIP_FOLLOWING ((guint) (1 << 1))
#define FRIENDSHIP_WANT_RETWEETS ((guint) (1 << 2))
#define FRIENDSHIP_BLOCKING ((guint) (1 << 3))
#define FRIENDSHIP_CAN_DM ((guint) (1 << 4))
GType cursor_get_type (void) G_GNUC_CONST;
Cursor* cursor_dup (const Cursor* self);
void cursor_free (Cursor* self);
void cursor_copy (const Cursor* self,
                  Cursor* dest);
void cursor_destroy (Cursor* self);
static void _vala_JsonNode_free (JsonNode* self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void user_utils_load_friendship_data_free (gpointer _data);
GType account_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Account, g_object_unref)
void user_utils_load_friendship (Account* account,
                                 gint64 user_id,
                                 const gchar* screen_name,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
guint user_utils_load_friendship_finish (GAsyncResult* _res_);
static gboolean user_utils_load_friendship_co (UserUtilsLoadFriendshipData* _data_);
GType sql_database_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SqlDatabase, g_object_unref)
GType notification_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NotificationManager, g_object_unref)
static void user_utils_load_friendship_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
static void user_utils_load_followers_data_free (gpointer _data);
void user_utils_load_followers (Account* account,
                                gint64 user_id,
                                Cursor* old_cursor,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
Cursor* user_utils_load_followers_finish (GAsyncResult* _res_);
static gboolean user_utils_load_followers_co (UserUtilsLoadFollowersData* _data_);
static void user_utils_load_followers_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void user_utils_load_following_data_free (gpointer _data);
void user_utils_load_following (Account* account,
                                gint64 user_id,
                                Cursor* old_cursor,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
Cursor* user_utils_load_following_finish (GAsyncResult* _res_);
static gboolean user_utils_load_following_co (UserUtilsLoadFollowingData* _data_);
static void user_utils_load_following_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void user_utils_mute_user_data_free (gpointer _data);
void user_utils_mute_user (Account* account,
                           gint64 to_block,
                           gboolean setting,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_);
void user_utils_mute_user_finish (GAsyncResult* _res_,
                                  GError** error);
static gboolean user_utils_mute_user_co (UserUtilsMuteUserData* _data_);
static Block55Data* block55_data_ref (Block55Data* _data55_);
static void block55_data_unref (void * _userdata_);
static void __lambda169_ (Block55Data* _data55_,
                   GObject* obj,
                   GAsyncResult* res);
GError* tweet_utils_failed_request_to_error (RestProxyCall* call,
                                             GError* e);
GQuark tweet_utils_get_error_domain (void);
static void ___lambda169__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void user_utils_block_user_data_free (gpointer _data);
void user_utils_block_user (Account* account,
                            gint64 to_block,
                            gboolean setting,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_);
void user_utils_block_user_finish (GAsyncResult* _res_,
                                   GError** error);
static gboolean user_utils_block_user_co (UserUtilsBlockUserData* _data_);
static Block56Data* block56_data_ref (Block56Data* _data56_);
static void block56_data_unref (void * _userdata_);
static void __lambda167_ (Block56Data* _data56_,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda167__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
	return g_boxed_copy (json_node_get_type (), self);
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
	return self ? _vala_JsonNode_copy (self) : NULL;
}

void
cursor_copy (const Cursor* self,
             Cursor* dest)
{
	JsonNode* _tmp0_;
	JsonNode* _tmp1_;
	(*dest).next_cursor = (*self).next_cursor;
	(*dest).full = (*self).full;
	_tmp0_ = (*self).json_object;
	_tmp1_ = __vala_JsonNode_copy0 (_tmp0_);
	__vala_JsonNode_free0 ((*dest).json_object);
	(*dest).json_object = _tmp1_;
}

void
cursor_destroy (Cursor* self)
{
	__vala_JsonNode_free0 ((*self).json_object);
}

Cursor*
cursor_dup (const Cursor* self)
{
	Cursor* dup;
	dup = g_new0 (Cursor, 1);
	cursor_copy (self, dup);
	return dup;
}

void
cursor_free (Cursor* self)
{
	cursor_destroy (self);
	g_free (self);
}

static GType
cursor_get_type_once (void)
{
	GType cursor_type_id;
	cursor_type_id = g_boxed_type_register_static ("Cursor", (GBoxedCopyFunc) cursor_dup, (GBoxedFreeFunc) cursor_free);
	return cursor_type_id;
}

GType
cursor_get_type (void)
{
	static volatile gsize cursor_type_id__volatile = 0;
	if (g_once_init_enter (&cursor_type_id__volatile)) {
		GType cursor_type_id;
		cursor_type_id = cursor_get_type_once ();
		g_once_init_leave (&cursor_type_id__volatile, cursor_type_id);
	}
	return cursor_type_id__volatile;
}

static void
user_utils_load_friendship_data_free (gpointer _data)
{
	UserUtilsLoadFriendshipData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_g_free0 (_data_->screen_name);
	g_slice_free (UserUtilsLoadFriendshipData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
user_utils_load_friendship (Account* account,
                            gint64 user_id,
                            const gchar* screen_name,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	UserUtilsLoadFriendshipData* _data_;
	Account* _tmp0_;
	gchar* _tmp1_;
	_data_ = g_slice_new0 (UserUtilsLoadFriendshipData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_load_friendship_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->user_id = user_id;
	_tmp1_ = g_strdup (screen_name);
	_g_free0 (_data_->screen_name);
	_data_->screen_name = _tmp1_;
	user_utils_load_friendship_co (_data_);
}

guint
user_utils_load_friendship_finish (GAsyncResult* _res_)
{
	guint result;
	UserUtilsLoadFriendshipData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
user_utils_load_friendship_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	UserUtilsLoadFriendshipData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	user_utils_load_friendship_co (_data_);
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static gboolean
user_utils_load_friendship_co (UserUtilsLoadFriendshipData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->call;
	rest_proxy_call_set_function (_data_->_tmp2_, "1.1/friendships/show.json");
	_data_->_tmp3_ = _data_->call;
	rest_proxy_call_set_method (_data_->_tmp3_, "GET");
	_data_->_tmp4_ = _data_->call;
	_data_->_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->account->id);
	_data_->_tmp6_ = _data_->_tmp5_;
	rest_proxy_call_add_param (_data_->_tmp4_, "source_id", _data_->_tmp6_);
	_g_free0 (_data_->_tmp6_);
	if (_data_->user_id != ((gint64) 0)) {
		_data_->_tmp7_ = _data_->call;
		_data_->_tmp8_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->user_id);
		_data_->_tmp9_ = _data_->_tmp8_;
		rest_proxy_call_add_param (_data_->_tmp7_, "target_id", _data_->_tmp9_);
		_g_free0 (_data_->_tmp9_);
	} else {
		_data_->_tmp10_ = _data_->call;
		rest_proxy_call_add_param (_data_->_tmp10_, "target_screen_name", _data_->screen_name);
	}
	_data_->root = NULL;
	{
		_data_->_tmp12_ = _data_->call;
		_data_->_state_ = 1;
		cb_utils_load_threaded_async (_data_->_tmp12_, NULL, user_utils_load_friendship_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp13_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp11_ = _data_->_tmp13_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp14_ = _data_->_tmp11_;
		_data_->_tmp11_ = NULL;
		__vala_JsonNode_free0 (_data_->root);
		_data_->root = _data_->_tmp14_;
		__vala_JsonNode_free0 (_data_->_tmp11_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp15_ = _data_->e;
		_data_->_tmp16_ = _data_->_tmp15_->message;
		g_warning ("UserUtils.vala:51: %s", _data_->_tmp16_);
		_data_->result = (guint) 0;
		_g_error_free0 (_data_->e);
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp17_ = _data_->root;
	_data_->_tmp18_ = json_node_get_object (_data_->_tmp17_);
	_data_->_tmp19_ = json_object_get_object_member (_data_->_tmp18_, "relationship");
	_data_->_tmp20_ = _json_object_ref0 (_data_->_tmp19_);
	_data_->relationship = _data_->_tmp20_;
	_data_->_tmp21_ = _data_->relationship;
	_data_->_tmp22_ = json_object_get_object_member (_data_->_tmp21_, "target");
	_data_->_tmp23_ = _json_object_ref0 (_data_->_tmp22_);
	_data_->target = _data_->_tmp23_;
	_data_->_tmp24_ = _data_->relationship;
	_data_->_tmp25_ = json_object_get_object_member (_data_->_tmp24_, "source");
	_data_->_tmp26_ = _json_object_ref0 (_data_->_tmp25_);
	_data_->source = _data_->_tmp26_;
	_data_->friendship = (guint) 0;
	_data_->_tmp27_ = _data_->target;
	if (json_object_get_boolean_member (_data_->_tmp27_, "following")) {
		_data_->friendship |= FRIENDSHIP_FOLLOWED_BY;
	}
	_data_->_tmp28_ = _data_->target;
	if (json_object_get_boolean_member (_data_->_tmp28_, "followed_by")) {
		_data_->friendship |= FRIENDSHIP_FOLLOWING;
	}
	_data_->_tmp29_ = _data_->source;
	if (json_object_get_boolean_member (_data_->_tmp29_, "want_retweets")) {
		_data_->friendship |= FRIENDSHIP_WANT_RETWEETS;
	}
	_data_->_tmp30_ = _data_->source;
	if (json_object_get_boolean_member (_data_->_tmp30_, "blocking")) {
		_data_->friendship |= FRIENDSHIP_BLOCKING;
	}
	_data_->_tmp31_ = _data_->source;
	if (json_object_get_boolean_member (_data_->_tmp31_, "can_dm")) {
		_data_->friendship |= FRIENDSHIP_CAN_DM;
	}
	_data_->result = _data_->friendship;
	_json_object_unref0 (_data_->source);
	_json_object_unref0 (_data_->target);
	_json_object_unref0 (_data_->relationship);
	__vala_JsonNode_free0 (_data_->root);
	_g_object_unref0 (_data_->call);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_load_followers_data_free (gpointer _data)
{
	UserUtilsLoadFollowersData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_cursor_free0 (_data_->old_cursor);
	_cursor_free0 (_data_->result);
	g_slice_free (UserUtilsLoadFollowersData, _data_);
}

static gpointer
_cursor_dup0 (gpointer self)
{
	return self ? cursor_dup (self) : NULL;
}

void
user_utils_load_followers (Account* account,
                           gint64 user_id,
                           Cursor* old_cursor,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	UserUtilsLoadFollowersData* _data_;
	Account* _tmp0_;
	Cursor* _tmp1_;
	_data_ = g_slice_new0 (UserUtilsLoadFollowersData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_load_followers_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->user_id = user_id;
	_tmp1_ = _cursor_dup0 (old_cursor);
	_cursor_free0 (_data_->old_cursor);
	_data_->old_cursor = _tmp1_;
	user_utils_load_followers_co (_data_);
}

Cursor*
user_utils_load_followers_finish (GAsyncResult* _res_)
{
	Cursor* result;
	UserUtilsLoadFollowersData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
user_utils_load_followers_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	UserUtilsLoadFollowersData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	user_utils_load_followers_co (_data_);
}

static gpointer
_json_array_ref0 (gpointer self)
{
	return self ? json_array_ref (self) : NULL;
}

static gboolean
user_utils_load_followers_co (UserUtilsLoadFollowersData* _data_)
{
	static const gint requested = 25;
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->call;
	rest_proxy_call_set_function (_data_->_tmp2_, "1.1/followers/list.json");
	_data_->_tmp3_ = _data_->call;
	rest_proxy_call_set_method (_data_->_tmp3_, "GET");
	_data_->_tmp4_ = _data_->call;
	_data_->_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->user_id);
	_data_->_tmp6_ = _data_->_tmp5_;
	rest_proxy_call_add_param (_data_->_tmp4_, "user_id", _data_->_tmp6_);
	_g_free0 (_data_->_tmp6_);
	_data_->_tmp7_ = _data_->call;
	_data_->_tmp8_ = g_strdup_printf ("%i", requested);
	_data_->_tmp9_ = _data_->_tmp8_;
	rest_proxy_call_add_param (_data_->_tmp7_, "count", _data_->_tmp9_);
	_g_free0 (_data_->_tmp9_);
	_data_->_tmp10_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp10_, "skip_status", "true");
	_data_->_tmp11_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp11_, "include_user_entities", "false");
	if (_data_->old_cursor != NULL) {
		_data_->_tmp12_ = _data_->call;
		_data_->_tmp13_ = g_strdup_printf ("%" G_GINT64_FORMAT, (*_data_->old_cursor).next_cursor);
		_data_->_tmp14_ = _data_->_tmp13_;
		rest_proxy_call_add_param (_data_->_tmp12_, "cursor", _data_->_tmp14_);
		_g_free0 (_data_->_tmp14_);
	}
	_data_->root = NULL;
	{
		_data_->_tmp16_ = _data_->call;
		_data_->_state_ = 1;
		cb_utils_load_threaded_async (_data_->_tmp16_, NULL, user_utils_load_followers_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp17_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp15_ = _data_->_tmp17_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp18_ = _data_->_tmp15_;
		_data_->_tmp15_ = NULL;
		__vala_JsonNode_free0 (_data_->root);
		_data_->root = _data_->_tmp18_;
		__vala_JsonNode_free0 (_data_->_tmp15_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp19_ = _data_->e;
		_data_->_tmp20_ = _data_->_tmp19_->message;
		g_warning ("UserUtils.vala:99: %s", _data_->_tmp20_);
		_data_->result = NULL;
		_g_error_free0 (_data_->e);
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp21_ = _data_->root;
	_data_->_tmp22_ = json_node_get_object (_data_->_tmp21_);
	_data_->_tmp23_ = _json_object_ref0 (_data_->_tmp22_);
	_data_->root_obj = _data_->_tmp23_;
	_data_->_tmp24_ = _data_->root_obj;
	_data_->_tmp25_ = json_object_get_array_member (_data_->_tmp24_, "users");
	_data_->_tmp26_ = _json_array_ref0 (_data_->_tmp25_);
	_data_->user_array = _data_->_tmp26_;
	memset (&_data_->cursor, 0, sizeof (Cursor));
	_data_->_tmp27_ = _data_->root_obj;
	_data_->cursor.next_cursor = json_object_get_int_member (_data_->_tmp27_, "next_cursor");
	_data_->_tmp28_ = _data_->user_array;
	_data_->cursor.full = json_array_get_length (_data_->_tmp28_) < ((guint) requested);
	_data_->_tmp29_ = _data_->root_obj;
	_data_->_tmp30_ = json_object_get_member (_data_->_tmp29_, "users");
	_data_->_tmp31_ = __vala_JsonNode_copy0 (_data_->_tmp30_);
	__vala_JsonNode_free0 (_data_->cursor.json_object);
	_data_->cursor.json_object = _data_->_tmp31_;
	_data_->_tmp32_ = _data_->cursor;
	_data_->_tmp33_ = _cursor_dup0 (&_data_->_tmp32_);
	_data_->_tmp34_ = _data_->_tmp33_;
	cursor_destroy (&_data_->_tmp32_);
	_data_->result = _data_->_tmp34_;
	_json_array_unref0 (_data_->user_array);
	_json_object_unref0 (_data_->root_obj);
	__vala_JsonNode_free0 (_data_->root);
	_g_object_unref0 (_data_->call);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_load_following_data_free (gpointer _data)
{
	UserUtilsLoadFollowingData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_cursor_free0 (_data_->old_cursor);
	_cursor_free0 (_data_->result);
	g_slice_free (UserUtilsLoadFollowingData, _data_);
}

void
user_utils_load_following (Account* account,
                           gint64 user_id,
                           Cursor* old_cursor,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	UserUtilsLoadFollowingData* _data_;
	Account* _tmp0_;
	Cursor* _tmp1_;
	_data_ = g_slice_new0 (UserUtilsLoadFollowingData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_load_following_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->user_id = user_id;
	_tmp1_ = _cursor_dup0 (old_cursor);
	_cursor_free0 (_data_->old_cursor);
	_data_->old_cursor = _tmp1_;
	user_utils_load_following_co (_data_);
}

Cursor*
user_utils_load_following_finish (GAsyncResult* _res_)
{
	Cursor* result;
	UserUtilsLoadFollowingData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static void
user_utils_load_following_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	UserUtilsLoadFollowingData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	user_utils_load_following_co (_data_);
}

static gboolean
user_utils_load_following_co (UserUtilsLoadFollowingData* _data_)
{
	static const gint requested = 25;
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->call;
	rest_proxy_call_set_function (_data_->_tmp2_, "1.1/friends/list.json");
	_data_->_tmp3_ = _data_->call;
	rest_proxy_call_set_method (_data_->_tmp3_, "GET");
	_data_->_tmp4_ = _data_->call;
	_data_->_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->user_id);
	_data_->_tmp6_ = _data_->_tmp5_;
	rest_proxy_call_add_param (_data_->_tmp4_, "user_id", _data_->_tmp6_);
	_g_free0 (_data_->_tmp6_);
	_data_->_tmp7_ = _data_->call;
	_data_->_tmp8_ = g_strdup_printf ("%i", requested);
	_data_->_tmp9_ = _data_->_tmp8_;
	rest_proxy_call_add_param (_data_->_tmp7_, "count", _data_->_tmp9_);
	_g_free0 (_data_->_tmp9_);
	_data_->_tmp10_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp10_, "skip_status", "true");
	_data_->_tmp11_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp11_, "include_user_entities", "false");
	if (_data_->old_cursor != NULL) {
		_data_->_tmp12_ = _data_->call;
		_data_->_tmp13_ = g_strdup_printf ("%" G_GINT64_FORMAT, (*_data_->old_cursor).next_cursor);
		_data_->_tmp14_ = _data_->_tmp13_;
		rest_proxy_call_add_param (_data_->_tmp12_, "cursor", _data_->_tmp14_);
		_g_free0 (_data_->_tmp14_);
	}
	_data_->root = NULL;
	{
		_data_->_tmp16_ = _data_->call;
		_data_->_state_ = 1;
		cb_utils_load_threaded_async (_data_->_tmp16_, NULL, user_utils_load_following_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp17_ = cb_utils_load_threaded_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp15_ = _data_->_tmp17_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp18_ = _data_->_tmp15_;
		_data_->_tmp15_ = NULL;
		__vala_JsonNode_free0 (_data_->root);
		_data_->root = _data_->_tmp18_;
		__vala_JsonNode_free0 (_data_->_tmp15_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp19_ = _data_->e;
		_data_->_tmp20_ = _data_->_tmp19_->message;
		g_warning ("UserUtils.vala:135: %s", _data_->_tmp20_);
		_data_->result = NULL;
		_g_error_free0 (_data_->e);
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		__vala_JsonNode_free0 (_data_->root);
		_g_object_unref0 (_data_->call);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp21_ = _data_->root;
	_data_->_tmp22_ = json_node_get_object (_data_->_tmp21_);
	_data_->_tmp23_ = _json_object_ref0 (_data_->_tmp22_);
	_data_->root_obj = _data_->_tmp23_;
	_data_->_tmp24_ = _data_->root_obj;
	_data_->_tmp25_ = json_object_get_array_member (_data_->_tmp24_, "users");
	_data_->_tmp26_ = _json_array_ref0 (_data_->_tmp25_);
	_data_->user_array = _data_->_tmp26_;
	memset (&_data_->cursor, 0, sizeof (Cursor));
	_data_->_tmp27_ = _data_->root_obj;
	_data_->cursor.next_cursor = json_object_get_int_member (_data_->_tmp27_, "next_cursor");
	_data_->_tmp28_ = _data_->user_array;
	_data_->cursor.full = json_array_get_length (_data_->_tmp28_) < ((guint) requested);
	_data_->_tmp29_ = _data_->root_obj;
	_data_->_tmp30_ = json_object_get_member (_data_->_tmp29_, "users");
	_data_->_tmp31_ = __vala_JsonNode_copy0 (_data_->_tmp30_);
	__vala_JsonNode_free0 (_data_->cursor.json_object);
	_data_->cursor.json_object = _data_->_tmp31_;
	_data_->_tmp32_ = _data_->cursor;
	_data_->_tmp33_ = _cursor_dup0 (&_data_->_tmp32_);
	_data_->_tmp34_ = _data_->_tmp33_;
	cursor_destroy (&_data_->_tmp32_);
	_data_->result = _data_->_tmp34_;
	_json_array_unref0 (_data_->user_array);
	_json_object_unref0 (_data_->root_obj);
	__vala_JsonNode_free0 (_data_->root);
	_g_object_unref0 (_data_->call);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_mute_user_data_free (gpointer _data)
{
	UserUtilsMuteUserData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	g_slice_free (UserUtilsMuteUserData, _data_);
}

void
user_utils_mute_user (Account* account,
                      gint64 to_block,
                      gboolean setting,
                      GAsyncReadyCallback _callback_,
                      gpointer _user_data_)
{
	UserUtilsMuteUserData* _data_;
	Account* _tmp0_;
	_data_ = g_slice_new0 (UserUtilsMuteUserData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_mute_user_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->to_block = to_block;
	_data_->setting = setting;
	user_utils_mute_user_co (_data_);
}

void
user_utils_mute_user_finish (GAsyncResult* _res_,
                             GError** error)
{
	UserUtilsMuteUserData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

static Block55Data*
block55_data_ref (Block55Data* _data55_)
{
	g_atomic_int_inc (&_data55_->_ref_count_);
	return _data55_;
}

static void
block55_data_unref (void * _userdata_)
{
	Block55Data* _data55_;
	_data55_ = (Block55Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data55_->_ref_count_)) {
		_g_error_free0 (_data55_->err);
		_g_object_unref0 (_data55_->call);
		g_slice_free (Block55Data, _data55_);
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static void
__lambda169_ (Block55Data* _data55_,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		RestProxyCall* _tmp0_;
		_tmp0_ = _data55_->call;
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* tmp_err = NULL;
		RestProxyCall* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = _data55_->call;
		_tmp2_ = e;
		_tmp3_ = tweet_utils_failed_request_to_error (_tmp1_, _tmp2_);
		tmp_err = _tmp3_;
		if (_data55_->setting) {
			_tmp5_ = TRUE;
		} else {
			GError* _tmp6_;
			_tmp6_ = tmp_err;
			_tmp5_ = _tmp6_->domain != tweet_utils_get_error_domain ();
		}
		if (_tmp5_) {
			_tmp4_ = TRUE;
		} else {
			GError* _tmp7_;
			_tmp7_ = tmp_err;
			_tmp4_ = _tmp7_->code != 272;
		}
		if (_tmp4_) {
			GError* _tmp8_;
			GError* _tmp9_;
			_tmp8_ = tmp_err;
			_tmp9_ = _g_error_copy0 (_tmp8_);
			_g_error_free0 (_data55_->err);
			_data55_->err = _tmp9_;
		}
		_g_error_free0 (tmp_err);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	user_utils_mute_user_co (_data55_->_async_data_);
}

static void
___lambda169__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	__lambda169_ (self, source_object, res);
	block55_data_unref (self);
}

static gboolean
user_utils_mute_user_co (UserUtilsMuteUserData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data55_ = g_slice_new0 (Block55Data);
	_data_->_data55_->_ref_count_ = 1;
	_data_->_data55_->setting = _data_->setting;
	_data_->_data55_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->_data55_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->_data55_->call;
	rest_proxy_call_set_method (_data_->_tmp2_, "POST");
	if (_data_->_data55_->setting) {
		_data_->_tmp3_ = _data_->_data55_->call;
		rest_proxy_call_set_function (_data_->_tmp3_, "1.1/mutes/users/create.json");
		_data_->_tmp4_ = _data_->_data55_->call;
		rest_proxy_call_add_param (_data_->_tmp4_, "include_entities", "false");
		_data_->_tmp5_ = _data_->_data55_->call;
		rest_proxy_call_add_param (_data_->_tmp5_, "skip_status", "true");
	} else {
		_data_->_tmp6_ = _data_->_data55_->call;
		rest_proxy_call_set_function (_data_->_tmp6_, "1.1/mutes/users/destroy.json");
	}
	_data_->_tmp7_ = _data_->_data55_->call;
	_data_->_tmp8_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->to_block);
	_data_->_tmp9_ = _data_->_tmp8_;
	rest_proxy_call_add_param (_data_->_tmp7_, "user_id", _data_->_tmp9_);
	_g_free0 (_data_->_tmp9_);
	_data_->_data55_->err = NULL;
	_data_->_tmp10_ = _data_->_data55_->call;
	rest_proxy_call_invoke_async (_data_->_tmp10_, NULL, ___lambda169__gasync_ready_callback, block55_data_ref (_data_->_data55_));
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp11_ = _data_->_data55_->err;
	if (_data_->_tmp11_ != NULL) {
		_data_->_tmp12_ = _data_->_data55_->err;
		_data_->_tmp13_ = _g_error_copy0 (_data_->_tmp12_);
		_data_->_inner_error0_ = _data_->_tmp13_;
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		block55_data_unref (_data_->_data55_);
		_data_->_data55_ = NULL;
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	block55_data_unref (_data_->_data55_);
	_data_->_data55_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
user_utils_block_user_data_free (gpointer _data)
{
	UserUtilsBlockUserData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	g_slice_free (UserUtilsBlockUserData, _data_);
}

void
user_utils_block_user (Account* account,
                       gint64 to_block,
                       gboolean setting,
                       GAsyncReadyCallback _callback_,
                       gpointer _user_data_)
{
	UserUtilsBlockUserData* _data_;
	Account* _tmp0_;
	_data_ = g_slice_new0 (UserUtilsBlockUserData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_utils_block_user_data_free);
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp0_;
	_data_->to_block = to_block;
	_data_->setting = setting;
	user_utils_block_user_co (_data_);
}

void
user_utils_block_user_finish (GAsyncResult* _res_,
                              GError** error)
{
	UserUtilsBlockUserData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

static Block56Data*
block56_data_ref (Block56Data* _data56_)
{
	g_atomic_int_inc (&_data56_->_ref_count_);
	return _data56_;
}

static void
block56_data_unref (void * _userdata_)
{
	Block56Data* _data56_;
	_data56_ = (Block56Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data56_->_ref_count_)) {
		_g_error_free0 (_data56_->err);
		_g_object_unref0 (_data56_->call);
		g_slice_free (Block56Data, _data56_);
	}
}

static void
__lambda167_ (Block56Data* _data56_,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		RestProxyCall* _tmp0_;
		_tmp0_ = _data56_->call;
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* tmp_err = NULL;
		RestProxyCall* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = _data56_->call;
		_tmp2_ = e;
		_tmp3_ = tweet_utils_failed_request_to_error (_tmp1_, _tmp2_);
		tmp_err = _tmp3_;
		_tmp4_ = tmp_err;
		_tmp5_ = _tmp4_->message;
		g_debug ("UserUtils.vala:206: Error: %s", _tmp5_);
		if (_data56_->setting) {
			_tmp7_ = TRUE;
		} else {
			GError* _tmp8_;
			_tmp8_ = tmp_err;
			_tmp7_ = _tmp8_->domain != tweet_utils_get_error_domain ();
		}
		if (_tmp7_) {
			_tmp6_ = TRUE;
		} else {
			GError* _tmp9_;
			_tmp9_ = tmp_err;
			_tmp6_ = _tmp9_->code != 272;
		}
		if (_tmp6_) {
			GError* _tmp10_;
			GError* _tmp11_;
			_tmp10_ = tmp_err;
			_tmp11_ = _g_error_copy0 (_tmp10_);
			_g_error_free0 (_data56_->err);
			_data56_->err = _tmp11_;
		}
		_g_error_free0 (tmp_err);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	user_utils_block_user_co (_data56_->_async_data_);
}

static void
___lambda167__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	__lambda167_ (self, source_object, res);
	block56_data_unref (self);
}

static gboolean
user_utils_block_user_co (UserUtilsBlockUserData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data56_ = g_slice_new0 (Block56Data);
	_data_->_data56_->_ref_count_ = 1;
	_data_->_data56_->setting = _data_->setting;
	_data_->_data56_->_async_data_ = _data_;
	_data_->_tmp0_ = _data_->account->proxy;
	_data_->_tmp1_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp0_);
	_data_->_data56_->call = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->_data56_->call;
	rest_proxy_call_set_method (_data_->_tmp2_, "POST");
	if (_data_->_data56_->setting) {
		_data_->_tmp3_ = _data_->_data56_->call;
		rest_proxy_call_set_function (_data_->_tmp3_, "1.1/blocks/create.json");
	} else {
		_data_->_tmp4_ = _data_->_data56_->call;
		rest_proxy_call_set_function (_data_->_tmp4_, "1.1/blocks/destroy.json");
	}
	_data_->_tmp5_ = _data_->_data56_->call;
	_data_->_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->to_block);
	_data_->_tmp7_ = _data_->_tmp6_;
	rest_proxy_call_add_param (_data_->_tmp5_, "user_id", _data_->_tmp7_);
	_g_free0 (_data_->_tmp7_);
	_data_->_data56_->err = NULL;
	_data_->_tmp8_ = _data_->_data56_->call;
	rest_proxy_call_invoke_async (_data_->_tmp8_, NULL, ___lambda167__gasync_ready_callback, block56_data_ref (_data_->_data56_));
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp9_ = _data_->_data56_->err;
	if (_data_->_tmp9_ != NULL) {
		_data_->_tmp10_ = _data_->_data56_->err;
		_data_->_tmp11_ = _g_error_copy0 (_data_->_tmp10_);
		_data_->_inner_error0_ = _data_->_tmp11_;
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		block56_data_unref (_data_->_data56_);
		_data_->_data56_ = NULL;
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	block56_data_unref (_data_->_data56_);
	_data_->_data56_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

